# Smart Segments

{% hint style="success" %}
This is the official documentation of the `forestadmin-agent-django` and `forestadmin-agent-flask` Python agents.
{% endhint %}

Smart Segments should be quick to migrate, as the syntax is very similar to the legacy agent.

{% hint style="info" %}
You can find the full documentation of segment customization [here](/developer-guide-agents-python/agent-customization/segments.md).
{% endhint %}

## How to migrate

### Structure

Because the new Forest Admin agent is designed to work with multiple databases, the return value of the filter function is not a Sequelize or Mongoose condition anymore.

Instead, you'll be building a [condition tree](/developer-guide-agents-python/data-sources/getting-started/queries/filters.md#condition-trees) that will be translated to the appropriate database syntax by the agent.

### Performance

All queries cannot be expressed in the Forest Admin query interface, but many can.

You can have great performance improvements by using the Forest Admin query interface to build your conditions, instead of performing the query yourself, and then building a naive condition tree, which filters by primary key like in the example we're providing.

### Example

In this example, we migrate a segment that returns the 5 bestsellers of a product collection.

{% tabs %}
{% tab title="Before" %}

```python
from app.models import Product
from django.db.models import Q
from django_forest.utils.collection import Collection

class ProductsForest(Collection):
    def load(self):
        self.segments = [
            {
                "name": "best_sellers",
                "where": self.get_best_sellers
            }
        ]

    def get_best_sellers(self):
        products = Product.objects.raw("""
            SELECT products.id, COUNT(orders.*)
            FROM products
            JOIN orders ON orders.product_id = products.id
            GROUP BY products.id
            ORDER BY count DESC
            LIMIT 5;"""
        )
        return Q(id__in=[p.id for p in products])
```

{% endtab %}

{% tab title="After" %}

```python
from app.models import Product
from forestadmin.datasource_toolkit.context.collection_context import CollectionCustomizationContext

def best_sellers_segment_handler(context: CollectionCustomizationContext)
    products = Product.objects.raw("""
        SELECT products.id, COUNT(orders.*)
        FROM products
        JOIN orders ON orders.product_id = products.id
        GROUP BY products.id
        ORDER BY count DESC
        LIMIT 5;"""
    )
    return ConditionTreeLeaf("id", "in", [p.id for p in products])

agent.customize_collection("Products").add_segment(
    "best_sellers", best_seller_segment_handler
)
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.forestadmin.com/developer-guide-agents-python/getting-started/migrating/code-transformations/smart-segments.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
